
Dim objFileSecuritySetting
Dim strFile
strFile = Replace(InputBox("File path and name?"),"\","\\")
Set objFileSecuritySetting = _
 GetObject("winmgmts:Win32_LogicalFileSecuritySetting.path='" _
  & strFile & "'")
 
'FileSecuritySetting Basics
WScript.Echo objFileSecuritySetting.Description
If objFileSecuritySetting.ControlFlags And 1 Then _
 WScript.Echo " Default owner"
If objFileSecuritySetting.ControlFlags And 2 Then _
 WScript.Echo " Default group"
If objFileSecuritySetting.ControlFlags And 4 Then _
 WScript.Echo " DACL exists"
If objFileSecuritySetting.ControlFlags And 8 Then _
 WScript.Echo " Default DACL"
If objFileSecuritySetting.ControlFlags And 16 Then _
 WScript.Echo " SACL exists"
If objFileSecuritySetting.ControlFlags And 32 Then _
 WScript.Echo " Default SACL"
If objFileSecuritySetting.ControlFlags And 256 Then _
 WScript.Echo " DACL auto-inherit req"
If objFileSecuritySetting.ControlFlags And 512 Then _
 WScript.Echo " SACL auto-inherit req"
If objFileSecuritySetting.ControlFlags And 1024 Then _
 WScript.Echo " DACL auto-inherited"
If objFileSecuritySetting.ControlFlags And 2048 Then _
 WScript.Echo " SACL auto-inherited"
If objFileSecuritySetting.ControlFlags And 4096 Then _
 WScript.Echo " DACL Protected"
If objFileSecuritySetting.ControlFlags And 8192 Then _
 WScript.Echo " SACL Protected"
If objFileSecuritySetting.ControlFlags And 32768 Then _
 WScript.Echo " Self-relative"
WScript.Echo 

'security descriptor specifics
'working with a Win32_SecurityDescriptor instance
Dim intReturn, objSecDesc
intReturn = objFileSecuritySetting.GetSecurityDescriptor(objSecDesc)
WScript.Echo "Security Descriptor:"
If objSecDesc.ControlFlags And 1 Then _
 WScript.Echo " Default owner"
If objSecDesc.ControlFlags And 2 Then _
 WScript.Echo " Default group"
If objSecDesc.ControlFlags And 4 Then _
 WScript.Echo " DACL exists"
If objSecDesc.ControlFlags And 8 Then _
 WScript.Echo " Default DACL"
If objSecDesc.ControlFlags And 16 Then _
 WScript.Echo " SACL exists"
If objSecDesc.ControlFlags And 32 Then _
 WScript.Echo " Default SACL"
If objSecDesc.ControlFlags And 256 Then _
 WScript.Echo " DACL auto-inherit req"
If objSecDesc.ControlFlags And 512 Then _
 WScript.Echo " SACL auto-inherit req"
If objSecDesc.ControlFlags And 1024 Then _
 WScript.Echo " DACL auto-inherited"
If objSecDesc.ControlFlags And 2048 Then _
 WScript.Echo " SACL auto-inherited"
If objSecDesc.ControlFlags And 4096 Then _
 WScript.Echo " DACL Protected"
If objSecDesc.ControlFlags And 8192 Then _
 WScript.Echo " SACL Protected"
If objSecDesc.ControlFlags And 32768 Then _
 WScript.Echo " Self-relative"
WScript.Echo String(25,"-")

Dim objDACL, objTrustee, strAccount
objDACL = objSecDesc.DACL

'go throgh the ACEs on the DACL
'each is an instance of Win32_ACE
Dim objACE
For Each objACE In objDACL
    'get trustee for this ACE - Win32_Trustee instance
    Set objTrustee = objACE.Trustee
    strAccount = objTrustee.Domain & "\" & objTrustee.Name
    
    'write ACE type
    Select Case objACE.AceType
        case 0
            WScript.Echo strAccount & _
             " Allowed to:"
        Case 1
            WScript.Echo strAccount & _
             " Denied to:"
        Case 2
            WScript.Echo strAccount & _
             " Audit for:"
    End Select
    
    'write permissions
    If objACE.AccessMask And 1 Then _
     WScript.Echo " File: List Dir"
    If objACE.AccessMask And 2 Then _
     WScript.Echo " File: Add file"
    If objACE.AccessMask And 4 Then _
     WScript.Echo " File: Add Subdir"
    If objACE.AccessMask And 8 Then _
     WScript.Echo " File: Read EA"
    If objACE.AccessMask And 16 Then _
     WScript.Echo " File: Write EA"
    If objACE.AccessMask And 32 Then _
     WScript.Echo " File: Traverse"
    If objACE.AccessMask And 64 Then _
     WScript.Echo " File: Delete child"
    If objACE.AccessMask And 128 Then _
     WScript.Echo " File: Read attrs"
    If objACE.AccessMask And 256 Then _
     WScript.Echo " File: Write attrs"
    If objACE.AccessMask And 65536 Then _
     WScript.Echo " Delete"
    If objACE.AccessMask And 131072 Then _
     WScript.Echo " Read-control"
    If objACE.AccessMask And 262144 Then _
     WScript.Echo " Write-DACL"
    If objACE.AccessMask And 524288 Then _
     WScript.Echo " Write-owner"
    If objACE.AccessMask And 1048576 Then _
     WScript.Echo " Synchronize"
    
    'write flags
    If objACE.AceFlags And 1 Then _
     WScript.Echo " (Non-container child objects will inherit)"
    If objACE.AceFlags And 2 Then _
     WScript.Echo " (Container child objects will inherit)"
    If objACE.AceFlags And 4 Then _
     WScript.Echo " (ACE does not propogate inheritance)"
    If objACE.AceFlags And 8 Then _
     WScript.Echo " (Inherit-only ACE)"
    If objACE.AceFlags And 16 Then _
     WScript.Echo " (Inherited ACE)"
    
    'seperator
    WScript.Echo String(25,"-")
Next

