'GPOMasterSummary.vbs
Dim GPM,gpmConstants,gpmDomain
Dim collGPOS,gpmSearchCriteria,gpo
dim RootDSE,objDomain

set GPM=CreateObject("GPMGMT.GPM")
set gpmConstants=GPM.GetConstants

strFQDN=GetDomainFQDN

set gpmDomain=GPM.GetDomain(strFQDN,"",gpmConstants.UseAnyDC)
set gpmSearchCriteria=GPM.CreateSearchCriteria
set collGPOS=gpmDomain.SearchGPOs(gpmSearchCriteria)

wscript.Echo "Found " & collGPOS.Count & " group policy objects in " &_
gpmDomain.Domain & "(" & gpmDomain.DomainController & ")"

For Each gpo In collGPOS
    WScript.Echo gpo.Displayname & " [" & gpo.path & "]"
    gpo.GenerateReporttoFile gpmConstants.ReportHTML, gpo.Displayname &_
     ".html"
Next

WScript.Quit

'**********************************************
Function GetDomainFQDN()
 set RootDSE=GetObject("LDAP://RootDSE")
 DomainPath= RootDSE.Get("DefaultNamingContext")
 DomainPath=Replace(DomainPath,"DC=","")
 GetDomainFQDN=Replace(DomainPath,",",".")
End Function