'GPOMasterSummary.vbs
Dim GPM,gpmConstants,gpmDomain
dim collGPOS,gpmSearchCriteria,collSOMs
Dim gpo
dim RootDSE,objDomain
Dim objFSO,objFile
Dim objDict
strFile="GPOMaster.htm"
WScript.Echo "Building GPO Master Report"

Set objDict=CreateObject("Scripting.Dictionary")
Set objFSO=CreateObject("Scripting.FileSystemObject")
Set objFile=objFSO.CreateTextFile(strFile,True)
'build the beginning of the html report"
objFile.Writeline "<html>"
objFile.Writeline "<head>"
objFile.WriteLine "<style type=text/css>"
objFile.WriteLine "body   {font-size:80%; font-family:Tahoma;}"
objFile.WriteLine "table   { font-size:100%; width:100%; }"
objFile.WriteLine "</style>"
objFile.WriteLine"</head>"
objFile.WriteLine "<body>"
objFile.WriteLine "<H3>Group Policy Master Report</H3><hr>"

'Create GPMC object
Set GPM=CreateObject("GPMGMT.GPM")
'Create GPMC constant object
Set gpmConstants=GPM.GetConstants
strFQDN=GetDomainFQDN

set gpmDomain=GPM.GetDomain(strFQDN,"",gpmConstants.UsePDC)

set gpmSearchCriteria=GPM.CreateSearchCriteria
set collGPOS=gpmDomain.SearchGPOs(gpmSearchCriteria)

objFile.WriteLine  "Found " & collGPOS.Count &_
 " group policy objects in " & gpmDomain.Domain & " (" &_
  gpmDomain.DomainController & ")"

For Each gpo In collGPOS
objFile.WriteLine "<Table border=0 cellpadding=3 cellspacing=3>"
objFile.WriteLine "<tr><td align=Center><B><a href=" & CHR(34) &_
 gpo.Displayname & ".htm" & Chr(34) & " target=_Blank>" &_
 gpo.Displayname & "</a></B></td><td>" & gpo.path & "</td></tr>"
objFile.WriteLine "<tr><td></td><td>Created " & gpo.CreationTime &_
"<br> Modified " & gpo.ModificationTime &"</td></tr>"

'Get SOM Links
gpmSearchCriteria.Add gpmConstants.SearchPropertySOMLinks,_
gpmConstants.SearchOpContains,gpo
Set collSOMs=gpmDomain.SearchSOMs(gpmSearchCriteria)
objFile.WriteLine "<tr><td>Linked to " & collSOMs.Count &_
 " container(s)</td></tr>"
If collSOMs.Count>0 Then
For Each gpmSOM In collSOMs
objDict.RemoveAll
  Select Case gpmSOM.Type
   Case gpmConstants.SOMSite
    objFile.WriteLine "<tr><td align=Right>[Site] " & gpmSOM.Name &_
     "</td><td>" & gpmSOM.Path &"</td></tr>"
    Set gpmSecurityInfo=gpmSOM.GetSecurityInfo
    objFile.WriteLine "<tr><td colspan=2>" & gpmSecurityInfo.Count &_
     " SOM permission objects</td></tr>"
    For Each gpmPerm In gpmSecurityInfo
        GetPerms(gpmPerm)
    Next
    k=objDict.Keys
    For i=0 To objDict.Count-1
     Select Case k(i)
        Case gpmConstants.permSOMLink
        objFile.WriteLine "<tr><td align=right>SOM Linking</td></tr>"
        tmpArray=Split(objDict.Item(k(i)),"||")
        For j=0 To UBound(tmpArray)
          objFile.WriteLine "<tr><td></td><td align=left>" &_
           tmpArray(j)&"</td></tr>"
        Next
    End Select
    Next
   Case gpmConstants.SOMDomain
     objFile.WriteLine "<tr><td align=Right>[Domain] " & gpmSOM.Name &_
      "</td><td>" & gpmSOM.Path &"</td></tr>"
     Set gpmSecurityInfo=gpmSOM.GetSecurityInfo
     objFile.WriteLine "<tr><td colspan=2>" & gpmSecurityInfo.Count &_
      " SOM permission objects</td></tr>"
     
     For Each gpmPerm In gpmSecurityInfo
       GetPerms(gpmPerm)
     Next
     k=objDict.Keys
     For i=0 To objDict.Count-1
       Select Case k(i)
        Case gpmConstants.permSOMLink
        objFile.WriteLine "<tr><td align=Right>SOM Linking</td></tr>"
        tmpArray=Split(objDict.Item(k(i)),"||")
        For j=0 To UBound(tmpArray)
          objFile.WriteLine "<tr><td></td><td align=left>" &_
           tmpArray(j)&"</td></tr>"
        Next
        Case gpmConstants.permSOMLogging
        objFile.WriteLine "<tr><td align=Right>RSoP Logging</td></tr>"
        tmpArray=Split(objDict.Item(k(i)),"||")
        For j=0 To UBound(tmpArray)
          objFile.WriteLine "<tr><td></td><td align=left>" &_
           tmpArray(j)&"</td></tr>"
        Next
        Case gpmConstants.permSOMPlanning
        objFile.WriteLine "<tr><td align=Right>RSoPPlanning</td></tr>"
        tmpArray=Split(objDict.Item(k(i)),"||")
        For j=0 To UBound(tmpArray)
          objFile.WriteLine "<tr><td></td><td align=left>" &_
           tmpArray(j)&"</td></tr>"
        Next
       End Select
     Next
   Case gpmConstants.SOMOU
       objFile.WriteLine "<tr><td align=Right>[OU] " &gpmSOM.Name &_
        "</td><td>" & gpmSOM.Path &"</td></tr>"
       Set gpmSecurityInfo=gpmSOM.GetSecurityInfo
       objFile.WriteLine "<tr><td colspan=2>" & gpmSecurityInfo.Count &_
        " SOM permission objects</td></tr>"
       For Each gpmPerm In gpmSecurityInfo
           GetPerms(gpmPerm)
       Next
       k=objDict.Keys
       For i=0 To objDict.Count-1
        Select Case k(i)
          Case gpmConstants.permSOMLink
          objFile.WriteLine "<tr><td align=right>SOM Linking</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
          Case gpmConstants.permSOMGPOCreate
          objFile.WriteLine "<tr><td align=right>Create GPO</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
          Case gpmConstants.permSOMLogging
          objFile.WriteLine "<tr><td align=right>RSoP Logging</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
          Case gpmConstants.permSOMPlanning
          objFile.WriteLine "<tr><td align=right>RSoPPlanning</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
          Case gpmConstants.permSOMWMICreate
          objFile.WriteLine "<tr><td align=right>Create WMI Filters</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
          Case gpmConstants.permSOMWMIFullControl
          objFile.WriteLine "<tr><td align=right>Full WMI Control</td></tr>"
          tmpArray=Split(objDict.Item(k(i)),"||")
          For j=0 To UBound(tmpArray)
            objFile.WriteLine "<tr><td></td><td align=left>" &_
             tmpArray(j)&"</td></tr>"
          Next
        End Select                  
       Next
  End Select
Next
End If
'Get GPO permissions
'clear the dictionary
objDict.RemoveAll
Set gpmSecurityInfo=gpo.GetSecurityInfo
objFile.WriteLine "<tr><td colspan=2>" & gpmSecurityInfo.Count &_
 " GPO permission objects</td></tr>"
For Each gpmPerm In gpmSecurityInfo
GetPerms(gpmPerm)
Next
  k=objDict.Keys
  For i=0 To objDict.Count-1
    Select Case k(i)
        Case gpmConstants.permGPOApply  
            objFile.WriteLine "<tr><td align=right>GPO Applies</td></tr>"
            tmpArray=Split(objDict.Item(k(i)),"||")
            For j=0 To UBound(tmpArray)
              objFile.WriteLine "<tr><td></td><td align=left>" &_
               tmpArray(j)&"</td></tr>"
            Next 
        Case gpmConstants.permGPOCustom 
            objFile.WriteLine "<tr><td align=right>GPO Custom</td></tr>"
            tmpArray=Split(objDict.Item(k(i)),"||")
            For j=0 To UBound(tmpArray)
              objFile.WriteLine "<tr><td></td><td align=left>" &_
               tmpArray(j)&"</td></tr>"
            Next 
        Case gpmConstants.permGPOEdit 
            objFile.WriteLine "<tr><td align=right>GPO Edit</td></tr>"
            tmpArray=Split(objDict.Item(k(i)),"||")
            For j=0 To UBound(tmpArray)
              objFile.WriteLine "<tr><td></td><td align=left>" &_
               tmpArray(j)&"</td></tr>"
            Next 
        Case gpmConstants.permGPORead 
            objFile.WriteLine "<tr><td align=right>GPO Read</td></tr>"
            tmpArray=Split(objDict.Item(k(i)),"||")
            For j=0 To UBound(tmpArray)
              objFile.WriteLine "<tr><td></td><td align=left>" &_
               tmpArray(j)&"</td></tr>"
            Next 
        Case gpmConstants.permGPOEditSecurityAndDelete 
            objFile.WriteLine "<tr><td align=right>GPO Edit Security</td></tr>"
            tmpArray=Split(objDict.Item(k(i)),"||")
            For j=0 To UBound(tmpArray)
              objFile.WriteLine "<tr><td></td><td align=left>" &_
               tmpArray(j)&"</td></tr>"
            Next
    End Select
  Next
'Generate HTML Report
 gpo.GenerateReporttoFile gpmConstants.ReportHTML, ".\" &_
 gpo.Displayname & ".htm"
objFile.WriteLine "</Table><br><br>"
Next
objFile.WriteLine "<I>Report run " & Now &  "</I>"
objFile.WriteLine "</Body>"
objFile.WriteLine "</html>"
objFile.Close
WScript.Echo "Finished building report page."
WScript.Quit

'**********************************************
Function GetDomainFQDN()
Set RootDSE=GetObject("LDAP://RootDSE")
DomainPath= RootDSE.Get("DefaultNamingContext")
DomainPath=Replace(DomainPath,"DC=","")
GetDomainFQDN=Replace(DomainPath,",",".")
End Function
'**********************************************
Function ListTrustees(gpmPerm)
On Error Resume Next
  If gpmPerm.Trustee.TrusteeDSPath="" Then
   ListTrustees= gpmPerm.Trustee.TrusteeName
  Else
    ListTrustees= gpmPerm.Trustee.TrusteeName & " [" &_
     gpmPerm.Trustee.TrusteeDSPath & "]"
  End If
End Function
'**********************************************
Sub GetPerms(gpmPerm)

If objDict.Exists(gpmPerm.Permission) Then
    strTemp=objDict.Item(gpmPerm.Permission)
    objDict.Remove gpmPerm.Permission
    'WScript.Echo "Adding " & strTemp & "," & ListTrustees(gpmPerm)
    objDict.Add gpmPerm.permission,strTemp & "||" & ListTrustees(gpmPerm)
Else
    objDict.Add gpmPerm.Permission,ListTrustees(gpmPerm)
End If

End Sub
