Set objFSO = CreateObject("Scripting.FileSystemObject")
Set objVS = CreateObject("VirtualServer.Application")
For Each objVM In objVS.VirtualMachines

    If objVM.AutoStartAtLaunch Then
        strAuto = "Auto start"
    Else
        strAuto = "Manual start"
    End If
    
    strGuestOS = objVM.GuestOS.Name
    strDisks = objVM.HardDiskConnections.Count & " Disks"
    strNICs = objVM.NetworkAdapters.Count & " NICs"
    
    Select Case objVM.ShutdownActionOnQuit
        Case 0
            strAction = "Save state on quit"
        Case 1
            strAction = "Turn off on quit"
        Case 2
            strAction = "Shutdown on quit"
    End Select
    
    Select Case objVM.State
        Case 0
            strState = "Invalid"
        Case 1
            strState = "Off"
        Case 2
            strState = "Saved"
        Case 3
            strState = "Turning on"
        Case 4
            strState = "Restoring"
        Case 5
            strState = "Running"
        Case 6
            strState = "Paused"
        Case 7
            strState = "Saving"
        Case 8
            strState = "Turning off"
        Case 9
            strState = "Merging"
        Case 10
            strState = "Deleting"
    End Select
    
    If objVM.Undoable Then
        strUndo = "Undoable"
    Else
        strUndo = "Not undoable"
    End If

    WScript.Echo objVM.Name & ": " & _
     strUndo & "," & _
     strState & "," & _
     strAction & "," & _
     strGuestOS & "," & _
     strDisks & "," & _
     strNICs & "," & _
     strAuto
    
Next