Dim objFSO,objFldr,objFiles,objTS
strTitle="File Demo"

strDir=InputBox("What folder do you want to examine?",_
strTitle,"c:\files")
If strDir="" Then WScript.quit

Set objFSO=CreateObject("Scripting.FileSystemObject")
If objFSO.FolderExists(strDir) Then
	'open folder
	Set objFldr=objFSO.GetFolder(strDir)
	
	'get log file information by calling
	'the GetFileName function
	strFile=GetFileName
	If strFile="" Then 
		WScript.Quit
	Else
		'call validation subroutine
		ValidateFile strFile
	End If
Else
	WScript.Echo "Can't find " & strDir
	WScript.Quit
End If

objTS.WriteLine "Folder Report for " & strDir
'get files in this folder
'objFiles is a collection
Set objFiles=objFldr.Files

'initialize our counter
i=0
'set variable for total number of files in folder
t=objFiles.Count
'enumerate the collection of files
For Each file In objFiles
	'get file information and write to log file
	objTS.WriteLine file.Name & vbTab & file.size & " bytes" & vbTab &_
	file.DateCreated & vbTab & file.DateLastModified
 	i=i+1
	iPer=FormatPercent((i/t))
	WScript.StdOut.Writeline(iPer& " complete")
Next

'close file
objTS.Close
MsgBox "See " & strFile & " for results.",vbOKOnly+vbInformation,strTitle

WScript.Quit
'////////////////////////////////////////////////////////////////////////
Function GetFileName()
On Error Resume Next

GetFileName=InputBox("What is the name of the audit file you " &_
"want to create?",strTitle,"c:\filelog.txt")

End Function

'////////////////////////////////////////////////////////////////////////
Sub ValidateFile(strFile)
On Error Resume Next
'check if log file exists and if so
	'prompt user if they want to overwrite.
	If objFSO.FileExists(strFile) Then
		rc=MsgBox(strFile & " already exists.  Do you want " &_
		"to overwrite it?",vbYesNoCancel+vbQuestion,strTitle)
		Select Case rc
			Case vbYes
				WScript.Echo "Overwriting file " &_
				strFile
				Err.Clear
				'create our logfile by overwriting
				Set objTS=objFSO.CreateTextFile(strFile,True)
				If Err.Number<>0 Then
					strMsg="There was an error creating " &_
					strFile & VbCrLf & "Error#" & Err.Number &_
					" " & Err.Description
					MsgBox strMsg,vbOKOnly+vbCritical,strTitle
					WScript.Quit
				End If
			Case vbNo
				strFile=GetFileName
				ValidateFile strFile
			Case vbCancel
				WScript.Echo "Aborting the script"
				WScript.Quit
		End Select
	Else
		'create our log file
		Err.Clear
		Set objTS=objFSO.CreateTextFile(strFile)
		If Err.Number<>0 Then
			strMsg="There was an error creating " &_
			strFile & VbCrLf & "Error#" & Err.Number &_
			" " & Err.Description
			MsgBox strMsg,vbOKOnly+vbCritical,strTitle
			WScript.Quit
		End If
	End If
End Sub

