Function strGetDN(samAccount)

    'Given NT4 account name, find the distinguished name for the user account
    On Error Resume Next 
    Dim objConn,objCmd,objRS 
    Set objConn=Createobject("ADODB.Connection")
    Set objCmd=Createobject("ADODB.Command")
    
    strGetDN="NotFound"
    
    Set objRoot=Getobject("LDAP://RootDSE")
    Set objDomain=Getobject("LDAP://"& objRoot.get("DefaultNamingContext"))
    
    strQuery="Select sAMAccountname,cn,distinguishedname from '" & _ 
     objDomain.AdsPath & "' Where objectCategory='person' AND " & _
     "objectclass='user'" & _ 
     " AND sAMAccountName='" & samAccount & "'"
    
    set objCatalog=Getobject("GC:")
    for each objItem In objCatalog
        Set objGC=objItem
    Next
    
    objConn.Provider="ADSDSOobject"
    objConn.Open "Active Directory Provider"
    objCmd.ActiveConnection=objConn
    objCmd.Properties("Page Size") = 100
    objCmd.Properties("asynchronous")=True
    objCmd.Properties("Timeout") =30
    objCmd.Properties("Cache Results") = False
    objCmd.CommandText=strQuery
    
    set objRS=objCmd.Execute
    
    do while not objRS.EOF
        strGetDN=objRS.Fields("distinguishedname")
        objRS.movenext
    Loop
    
    objRS.Close
    objConn.Close
    
    set objConn=Nothing
    set objCmd=Nothing
    set objRoot=Nothing
    set objCatalog=Nothing
    set objRS=Nothing
    
End Function
