ComputerName = "."
Set wmiServices  = GetObject ( _
    "winmgmts:{impersonationLevel=Impersonate}!//" _
    & ComputerName)

' Get physical disk drive
Set wmiDiskDrives =  wmiServices.ExecQuery ( _
    "SELECT Caption, DeviceID FROM Win32_DiskDrive")

For Each wmiDiskDrive In wmiDiskDrives
    WScript.Echo "Disk drive Caption: " _
        & wmiDiskDrive.Caption _ 
        & VbCrLf & "DeviceID: " _
        & " (" & wmiDiskDrive.DeviceID & ")"

    'Backslash in disk drive deviceid
    ' must be escaped by "\"    
    strEscapedDeviceID = Replace( _
        wmiDiskDrive.DeviceID, "\", "\\")

    'Use the disk drive device id to
    ' find associated partition 
    Set wmiDiskPartitions = wmiServices.ExecQuery _
          ("ASSOCIATORS OF {Win32_DiskDrive.DeviceID='" _
          & strEscapedDeviceID & "'} WHERE " & _
          "AssocClass = Win32_DiskDriveToDiskPartition")

    For Each wmiDiskPartition In wmiDiskPartitions

        'Use partition device id to find logical disk
        Set wmiLogicalDisks = wmiServices.ExecQuery _
            ("ASSOCIATORS OF " _
                 & "{Win32_DiskPartition.DeviceID='" & _
             wmiDiskPartition.DeviceID & "'} WHERE " & _
             "AssocClass = Win32_LogicalDiskToPartition")

        For Each wmiLogicalDisk In wmiLogicalDisks
            WScript.Echo "Drive letter associated" _
                & " with disk drive = " _ 
                & wmiDiskDrive.Caption _
                & wmiDiskDrive.DeviceID _
                & VbCrLf & " Partition = " _
                & wmiDiskPartition.DeviceID _
                & VbCrLf & " is " _
                & wmiLogicalDisk.DeviceID
        Next
    Next
Next