'USAGE: cscript|wscript wmiprocessorquery.vbs server

Dim CPUSink,ProcSink,objShell
On error Resume Next

If (wscript.arguments.count=0) Then
 strMsg="Usage: " & VbCrLf
 strMsg=strMsg & "cscript|wscript processorquery.vbs server" & VbCrLf
 strMsg=strMsg & "example: cscript processorquery.vbs File02"
 wscript.echo strMsg
 wscript.quit
Else
 strSrv=wscript.arguments(0)
End If

'check every 30 seconds for processor load > 70%.  
strCPUQuery="Select * from __InstanceModificationEvent WITHIN 30 WHERE " &_
"TargetInstance ISA 'Win32_Processor' AND " &_
"TargetInstance.LoadPercentage >70"

'check every 10 seconds for existance of charmap.exe process
strProcQuery="Select * from __InstanceCreationEvent WITHIN 10 WHERE " &_
"TargetInstance ISA 'Win32_Process' AND " &_
"TargetInstance.Name='charmap.exe'"

Set objShell=CreateObject("Wscript.Shell")
Set CPUSink=wscript.CreateObject("WBemScripting.SWbemSink","CPUSINK_")
Set ProcSink=wscript.CreateObject("WBemScripting.SWbemSink","PROCSINK_")

Set oWMILocal=GetObject("winmgmts://")
oWMILocal.ExecNotificationQueryAsync ProcSink,strProcQuery
If err.number<>0 Then
 objShell.Popup "Oops! There was an error creating process event sink " &_
 "locally." & vbCrlf & "Error #" &err.number & vbCrlf &_
 "Description (if available): " & vbCrlf & " " & err.description &_
  vbCrlf & "Source (If available): " & VbCrLf & " " &_
   err.source,-1,"CPU Monitoring",vbOKOnly+vbCritical
 WScript.quit
Else
 Err.Clear
End If

Set oWMIRemote=GetObject("winmgmts://" & strSrv)
If err.number<>0 Then
 objShell.Popup "Oops!  There was an error connecting to " &_
  UCASE(strSrv) & vbCrlf & "Error #" &err.number & VbCrLf &_
  "Description (if available): " & VbCrLf & " " &_
  err.description & VbCrLf & "Source (If available): " & _
  vbCrlf & " " & Err.source,-1,"CPU Monitoring",vbOKOnly+vbCritical
 wscript.quit
Else
 oWMIRemote.ExecNotificationQueryAsync CPUSink,strCPUQuery
  If err.number<>0 Then
   objShell.Popup "Oops! There was an error creating CPU sink for " &_
    UCASE(strSrv) & vbCrlf & "Error #" &err.number & vbCrlf &_
     "Description (if available): " & vbCrlf & " " &_
      err.description & vbCrlf & "Source (If available): " & _
   vbCrlf & " " & err.source,-1,"CPU Monitoring",vbOKOnly+vbCritical
   wscript.quit
  Else
   err.Clear 
  End If
	
End If

objShell.popup "Launch CHARMAP to stop monitoring",3,"CPU Monitoring",0+32

blnLoop=True
'Check if trigger process has been run, sleeping every 5 seconds.
While blnLoop
	wscript.sleep 5
Wend

objShell.Popup "Cancelling monitoring.  You can go ahead and close " &_
"the trigger application.",3,"CPU Monitoring",vbOKOnly+vbInformation
objShell.AppActivate("Character Map")

CPUSink.Cancel()
ProcSink.Cancel()
wscript.DisconnectObject(CPUSink)
wscript.DisconnectObject(ProcSink)

Set oWMILocal=Nothing
Set oWMIRemote=Nothing
Set CPUSink=Nothing
Set ProcSink=Nothing
wscript.quit

'*******************************************************************
Sub CPUSINK_OnObjectReady(objEvent,objContext)
strSystem=objEvent.Path_.Server
'wscript.echo "fired " & NOW
objShell.popup "Processor load is " &_
 objEvent.TargetInstance.LoadPercentage & "%" & _
vbCrlf & NOW,-1,"System - " & strSystem,vbOKOnly+vbInformation
End Sub

Sub PROCSINK_OnObjectReady(objEvent,objContext)
'trigger has been detected to close out this script
  blnLoop=False
End Sub

'EOF