set oLocator = CreateObject("WbemScripting.SWbemLocator")
set oProvider = oLocator.ConnectServer("Server2", "root/MicrosoftIISv2")
set oService = oProvider.Get("IIsWebService='W3SVC'")

oBindings = Array(0)
Set oBindings(0) = oProvider.Get("ServerBinding").SpawnInstance_()
oBindings(0).IP = ""
oBindings(0).Port = "8383"
oBindings(0).Hostname = ""

Dim sSiteObjectPath
sSiteObjectPath = oService.CreateNewSite("NewWebSite", oBindings, "C:\Inetpub\Wwwroot")
If Err Then
WScript.Echo "*** Error Creating Site: " & Hex(Err.Number) & ": " & Err.Description & " ***"
WScript.Quit(1)
End If

Set oPath = CreateObject("WbemScripting.SWbemObjectPath")
oPath.Path = sSiteObjectPath
sSitePath = oPath.Keys.Item("")

Set oVirtualDir = oProvider.Get("IIsWebVirtualDirSetting='" & sSitePath & "/ROOT'")
oVirtualDir.AuthFlags = 5 ' AuthNTLM + AuthAnonymous
oVirtualDir.EnableDefaultDoc = True
oVirtualDir.DirBrowseFlags = &H4000003E ' date, time, size, extension, longdate
oVirtualDir.AccessFlags = 513 ' read, script
oVirtualDir.AppFriendlyName = "Root Application"

oVirtualDir.Put_()

Set oServer = oProvider.Get(sSiteObjectPath)
oServer.Start

WScript.Echo "Complete"