' requires Windows XP Service Pack 2 or later
'connect to the root of AD
Dim rootDSE, domainObject
Set rootDSE=GetObject("LDAP://RootDSE")
domainContainer = rootDSE.Get("defaultNamingContext")
Set oDomain = GetObject("LDAP://" & domainContainer)

'start with the domain root
WorkWithObject(oDomain)

Sub WorkWithObject(oContainer)
 Dim oADObject
 For Each oADObject in oContainer
  Select Case oADObject.Class
   Case "computer"
    'oADObject represents a COMPUTER object;
    'do something with it
    WScript.Echo String(40,"-")
    WScript.Echo oADObject.cn
    On Error Resume Next
    Set objWU = CreateObject("Microsoft.Update.AutoUpdate", _
     "\\" & oADObject.cn)
    If Err <> 0 Then
        WScript.Echo Err.Description
    Else     
        Set objSetting = objWU.Settings
        WScript.Echo "Notification: " & objSetting.NotificationLevel
        WScript.Echo "Read-only: " & objSetting.ReadOnly
        WScript.Echo "Required: " & objSetting.Required
        WScript.Echo "Install time: " & _
         objSetting.ScheduledInstallationDay
        WScript.Echo "Install day: " & _
         objSetting.ScheduledInstallationTime
    End If
Case "organizationalUnit" , "container"
    'oADObject is an OU or container...
    'go through its objects
    WorkWithObject(oADObject)
  End Select
 Next
End Sub