Dim GPM,gpmConstants,gpmDomain
dim collGPOS,gpmSearchCriteria,collSOMs
dim RootDSE,objDomain

Set GPM=CreateObject("GPMGMT.GPM")
set gpmConstants=GPM.GetConstants
strFQDN=GetDomainFQDN

set gpmDomain=GPM.GetDomain(strFQDN,"",gpmConstants.UsePDC)
set gpmSearchCriteria=GPM.CreateSearchCriteria
set collGPOS=gpmDomain.SearchGPOs(gpmSearchCriteria)

wscript.Echo "Found " & collGPOS.Count & " group policy objects in " &_
gpmDomain.Domain & "(" & gpmDomain.DomainController & ")"
For Each gpo In collGPOS
    WScript.Echo gpo.Displayname & " [" & gpo.id & "]"
    gpmSearchCriteria.Add gpmConstants.SearchPropertySOMLinks,_
    gpmConstants.SearchOpContains,gpo
    Set collSOMs=gpmDomain.SearchSOMs(gpmSearchCriteria)
    WScript.Echo "Linked to " & collSOMs.Count & " container(s)"
    If collSOMs.Count>0 Then
        For Each gpmSOM In collSOMs
            Select Case gpmSOM.Type
                Case gpmConstants.SOMSite
                    WScript.Echo vbtab & "Site:" & gpmSOM.Name
    
                Case gpmConstants.SOMDomain
                    WScript.Echo vbTab & "Domain:" & gpmSOM.Name
    
                Case gpmConstants.SOMOU
                    WScript.Echo vbTab & "OU:" &gpmSOM.Name
            End Select
        Next
    End if

Next

WScript.Quit

'**********************************************
Function GetDomainFQDN()
 set RootDSE=GetObject("LDAP://RootDSE")
 DomainPath= RootDSE.Get("DefaultNamingContext")
 DomainPath=Replace(DomainPath,"DC=","")
 GetDomainFQDN=Replace(DomainPath,",",".")
End Function