Dim GPM,gpmConstants,gpmDomain
dim collGPOS,gpmSearchCriteria,gpo
Dim gpmResult,gpmSecurityInfo,gpmPerm
dim RootDSE,objDomain

set GPM=CreateObject("GPMGMT.GPM")
set gpmConstants=GPM.GetConstants
strFQDN=GetDomainFQDN

set gpmDomain=GPM.GetDomain(strFQDN,"",gpmConstants.UseAnyDC)

set gpmSearchCriteria=GPM.CreateSearchCriteria
set collGPOS=gpmDomain.SearchGPOs(gpmSearchCriteria)
wscript.Echo "Found " & collGPOS.Count & " group policy objects in " &_
gpmDomain.Domain & "(" & gpmDomain.DomainController & ")"

For Each gpo In collGPOS
    WScript.Echo gpo.Displayname
    set gpmSecurityInfo=gpo.GetSecurityInfo
    wscript.Echo gpmSecurityInfo.Count & " permission objects"
  For Each gpmPerm In gpmSecurityInfo
    Select Case gpmPerm.permission
        Case gpmConstants.permGPOApply  
            WScript.Echo vbTab & "GPO Applies"
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
        Case gpmConstants.permGPOCustom 
            WScript.Echo vbTab & "GPO Custom"
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
        Case gpmConstants.permGPOEdit 
            WScript.Echo vbTab & "GPO Edit"
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
        Case gpmConstants.permGPORead 
            WScript.Echo vbTab & "GPO Read"
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
        Case gpmConstants.permGPOEditSecurityAndDelete 
            WScript.Echo vbTab & "GPO Edit Security"
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
        Case Else 
            WScript.Echo vbTab & gpmPerm.Permission
            wscript.Echo vbTab & vbTab & ListTrustees(gpmPerm)
    End select
    next
Next

WScript.Quit

'**********************************************
Function GetDomainFQDN()
set RootDSE=GetObject("LDAP://RootDSE")
DomainPath= RootDSE.Get("DefaultNamingContext")
DomainPath=Replace(DomainPath,"DC=","")
GetDomainFQDN=Replace(DomainPath,",",".")
End Function

'**********************************************
Function ListTrustees(gpmPerm)
On Error Resume Next
  If gpmPerm.Trustee.TrusteeDSPath="" Then
   ListTrustees= gpmPerm.Trustee.TrusteeName
  Else
    ListTrustees= gpmPerm.Trustee.TrusteeName & " [" &_
     gpmPerm.Trustee.TrusteeDSPath & "]"
  End If
End Function