strTitle="Create New MailBox Store"
strServer=InputBox("What is the name of the Exchange Server?",_
strTitle,"MAIL01")
strSG=InputBox("What is the name of the storage group to create the" &_
" new mailstore under?",strTitle,"First Storage Group")
strMDBName=InputBox("What is the name of the new mail store?",_
strTitle,"ScriptingAnswers Mail")

CreateNewMailStoreDB strMDBName,strServer,strSG
WScript.Quit

Sub CreateNewMailStoreDB(strMDBName,strServer,strSG)

Dim iServer        
Dim iMDB 

Set iServer=CreateObject("CDOEXM.ExchangeServer")
Set iMDB=CreateObject("CDOEXM.MailboxStoreDB")
' Set the name of the MailboxStoreDB
iMDB.Name = strMDBName

' Bind to the Exchange Server
iServer.DataSource.Open strServer

' Start to build the URL to the MailboxStoreDB - first part
strTemp = "LDAP://" & iServer.DirectoryServer & "/" & "cn=" &_
 strMDBName & ","

arrStGroup = iServer.StorageGroups

' Look in the StorageGroups array if the StorageGroup with strSG exists
If strSG = "" Then
 ' Finish to build the URL to the MailboxStoreDB - add last part
 strMDBUrl = strTemp & iServer.StorageGroups(0)
Else
 For i = 0 To UBound(arrStGroup)
     If InStr(1, UCase(arrStGroup(i)), UCase(strSG)) <> 0 Then
         strMDBUrl = arrStGroup(i)
     End If
 Next
 If strMDBUrl <> "" Then
     ' Finish to build the URL to the MailboxStoreDB - add last part
     strMDBUrl = strTemp & strMDBUrl
 End If
End If

' Save the New MailboxStoreDB
iMDB.DataSource.SaveTo strMDBUrl

' Mount the MailboxStoreDB
 iMDB.Mount
WScript.Echo "Finished creating " & strMDBName
End Sub
